//+------------------------------------------------------------------+
//|                                          Guppy MMA oscilator.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

extern double alLots          = 1.0;
extern int    Price           = PRICE_CLOSE;
extern int    SignalPeriod    = 13;
////////////////////////////////////////////////
int    Magic           = 712506;
string EA_Tester       = "mladen";
int    MaxOrders       = 1;
double buffer1[];
double buffer2[];
double periods[]={3,5,8,10,12,15,30,35,40,45,50,60};
int    persize;
//--------------------------------------------------------------------
int init()
  {  
   persize =ArraySize(periods);
   return(0);
}
//--------------------------------------------------------------------
int deinit() { return(0); }
//--------------------------------------------------------------------
int start()
  {
   //--------------------------------------------------------------------   
   double alpha = 2.0/(1.0+SignalPeriod);
   int counted_bars=IndicatorCounted();
   int i,limit;
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit = Bars-counted_bars;         
   //--------------------------------------------------------------------
   for(i=limit; i>=0; i--) {
      double sum  = 0;
      for(int j=0; j<persize; j++)
      {
         if (periods[j]<30)
               sum  += iMA(NULL,0,periods[j],0,MODE_EMA,Price,i);
         else  sum  -= iMA(NULL,0,periods[j],0,MODE_EMA,Price,i);
      }
      buffer1[i] = sum*10.0;
      buffer2[i] = buffer2[i+1]+alpha*(buffer1[i]-buffer2[i+1]);
      Print("|limit: ", limit, "|counted_bars: ", counted_bars, " - ", buffer1[i], " - ",buffer2[i]);
   }
   if ((buffer1[0] < buffer2[0])&&(buffer1[1] < buffer2[1])&&(buffer1[3] > buffer2[3])&&(buffer1[4] > buffer2[4])) OpenbyBuying();
   if ((buffer1[0] > buffer2[0])&&(buffer1[1] > buffer2[1])&&(buffer1[3] < buffer2[3])&&(buffer1[4] < buffer2[4])) OpenbySelling();
  //--------------------------------------------------------------------
  return(0);   // Exit start()
  }
//--------------------------------------------------------------------
void OpenbyBuying() {
  if (CountOrders(Magic,OP_BUY) < MaxOrders) {
     Alert("Kupujem");
     OrderSend(Symbol(),OP_BUY,alLots,Ask,3,0,0,EA_Tester,Magic);
  }
}
//--------------------------------------------------------------------
void OpenbySelling() {
  if (CountOrders(Magic,OP_SELL) < MaxOrders) {
     Alert("Prodajem");
     OrderSend(Symbol(),OP_SELL,alLots,Bid,3,0,0,EA_Tester,Magic); 
  }
}
//--------------------------------------------------------------------
int CountOrders(int Magic, int alType)
{
   int _CountOrd;
   _CountOrd=0;
   for(int i=0;i<OrdersTotal();i++)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol()) if(((OrderMagicNumber()==Magic)||Magic==0)&&(alType == OrderType())) _CountOrd++;
   }
   return(_CountOrd);
}
//--------------------------------------------------------------------